package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.eam_core.domain.EMAssetClass;
import cn.ibizlab.eam.core.eam_core.filter.EMAssetClassSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMAssetClass] 服务对象接口
 */
public interface IEMAssetClassService extends IService<EMAssetClass>{

    boolean checkKey(EMAssetClass et) ;
    EMAssetClass getDraft(EMAssetClass et) ;
    boolean save(EMAssetClass et) ;
    void saveBatch(List<EMAssetClass> list) ;
    boolean update(EMAssetClass et) ;
    void updateBatch(List<EMAssetClass> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(EMAssetClass et) ;
    void createBatch(List<EMAssetClass> list) ;
    EMAssetClass get(String key) ;
    Page<EMAssetClass> searchDefault(EMAssetClassSearchContext context) ;
    List<EMAssetClass> selectByAssetclasspid(String emassetclassid) ;
    void removeByAssetclasspid(String emassetclassid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EMAssetClass> getEmassetclassByIds(List<String> ids) ;
    List<EMAssetClass> getEmassetclassByEntities(List<EMAssetClass> entities) ;

}


